linear-1.20.7: Linear Algebra

License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | provisional
Portability | portable
Safe Haskell | None
Language | Haskell98

Linear.Covector

Description

Operations on affine spaces.

Synopsis

- newtype Covector r a = Covector {
  - runCovector :: (a -> r) -> r
  }
- ($*) :: Representable f => Covector r (Rep f) -> f r -> r

# Documentation

newtype Covector r a Source #

Linear functionals from elements of an (infinite) free module to a scalar

Constructors

Covector |

Fields

- runCovector :: (a -> r) -> r

Instances

Monad (Covector r) Source # |
Methods (>>=) :: Covector r a -> (a -> Covector r b) -> Covector r b # (>>) :: Covector r a -> Covector r b -> Covector r b # return :: a -> Covector r a # fail :: String -> Covector r a #
Functor (Covector r) Source # |
Methods fmap :: (a -> b) -> Covector r a -> Covector r b # (<$) :: a -> Covector r b -> Covector r a #
Applicative (Covector r) Source # |
Methods pure :: a -> Covector r a # (<*>) :: Covector r (a -> b) -> Covector r a -> Covector r b # (*>) :: Covector r a -> Covector r b -> Covector r b # (<*) :: Covector r a -> Covector r b -> Covector r a #
Num r => Alternative (Covector r) Source # |
Methods empty :: Covector r a # (<|>) :: Covector r a -> Covector r a -> Covector r a # some :: Covector r a -> Covector r [a] # many :: Covector r a -> Covector r [a] #
Num r => MonadPlus (Covector r) Source # |
Methods mzero :: Covector r a # mplus :: Covector r a -> Covector r a -> Covector r a #
Num r => Plus (Covector r) Source # |
Methods zero :: Covector r a #
Num r => Alt (Covector r) Source # |
Methods (<!>) :: Covector r a -> Covector r a -> Covector r a # some :: Applicative (Covector r) => Covector r a -> Covector r [a] # many :: Applicative (Covector r) => Covector r a -> Covector r [a] #
Apply (Covector r) Source # |
Methods (<.>) :: Covector r (a -> b) -> Covector r a -> Covector r b # (.>) :: Covector r a -> Covector r b -> Covector r b # (<.) :: Covector r a -> Covector r b -> Covector r a #
Bind (Covector r) Source # |
Methods (>>-) :: Covector r a -> (a -> Covector r b) -> Covector r b # join :: Covector r (Covector r a) -> Covector r a #
Coalgebra r m => Num (Covector r m) Source # |
Methods (+) :: Covector r m -> Covector r m -> Covector r m # (-) :: Covector r m -> Covector r m -> Covector r m # (*) :: Covector r m -> Covector r m -> Covector r m # negate :: Covector r m -> Covector r m # abs :: Covector r m -> Covector r m # signum :: Covector r m -> Covector r m # fromInteger :: Integer -> Covector r m #

($*) :: Representable f => Covector r (Rep f) -> f r -> r infixr 0 Source #